﻿using System.Collections.Generic;

using Newtonsoft.Json.Linq;

using Sers.Core.CL.MessageOrganize;
using Sers.Core.CL.MessageOrganize.DefaultOrganize;

using Vit.Extensions;
using Vit.Extensions.Newtonsoft_Extensions;

namespace Sers.CL.WebSocket
{
    public class OrganizeClientBuilder : IOrganizeClientBuilder
    {
        public void Build(List<IOrganizeClient> organizeList, JObject config)
        {
            var delivery = new DeliveryClient();

            #region security        
            if (config["security"] is JArray securityConfigs)
            {
                var securityManager = Sers.Core.Util.StreamSecurity.SecurityManager.BuildSecurityManager(securityConfigs);
                ((DeliveryClient_Connection)delivery.conn).securityManager = securityManager;
            }
            #endregion

            delivery.host = config["host"]?.ConvertToString() ?? delivery.host;
            delivery.validateRemoteCertificate = config["validateRemoteCertificate"]?.Deserialize<bool?>() ?? delivery.validateRemoteCertificate;


            organizeList.Add(new OrganizeClient(delivery, config));
        }
    }
}
